import { Streamie, Handler, Config } from './types';
export default function streamie<HI extends any, HO extends any, C extends Config>(handler: Handler<HI, HO>, config: C): {
    push: (...items: HI[]) => void;
    map: <NHO extends unknown, C_1 extends Config>(handler: Handler<HO, NHO>, config: C_1) => Streamie<HO, NHO>;
    filter: <NHO_1 extends unknown, C_2 extends Config>(handler: Handler<HO, NHO_1>, config: C_2) => Streamie<HO, NHO_1>;
    pause: (shouldPause?: boolean) => void;
    drain: () => void;
    state: {
        readonly backpressure: boolean;
        readonly count: {
            handling: number;
        };
        readonly isPaused: boolean;
        readonly isDrained: boolean;
        readonly isHalted: boolean;
    };
    onBackpressureRelease: (eventHandler: () => void) => void;
    onDrained: (eventHandler: () => void) => void;
    onError: (eventHandler: (payload: {
        input: HI[];
        error: any;
    }) => void) => void;
    promise: Promise<null>;
};
